(*Mathematica:: Version 7.0 *)
(*:Context:: "surrogate`" *)
(*:Title:: core estimates*)
(*Requirements:*)
 (*Date   2017 Stuart G. Baker *)  					
(*SFitPlot  sfitplot.m*)


BeginPackage["sfitdatasim`","sfitplot`","sfitlik`"]  


GenDataSim::usage="GenDataSim"

Clear[GenDataSim]

Begin["Private`"]


GenDataSim[datanum_,sizetype_]:=
Module[{len,sigmaT, ntype,difSvec,input,res1,res2,res3,res,wvec,seratio,n,name},
b=.7;
n=60;
seW=3;
sigmaT=Sqrt[n] seW;
If[datanum==1, len=6;  b=4;   sigmaB=7];
If[datanum==2, len=6;  b=3;   sigmaB=6];
If[datanum==3, len=10;  b=3;   sigmaB=2];
difSvec=Range[len];
SeedRandom[18];
difSvec0=Sort@Table[Random[] len, len];
difSvec=Round[difSvec0 100]/100//N;
If[sizetype==1, ntype="constant size";  nvec0=Table[n,len]];
If[sizetype==2, ntype="increasing size"; nvec0=(.2 + Range[len]/len) n];
If[sizetype==3, ntype="deceasing size"; nvec0=Reverse@(.2+ Range[len]/len) n];
If[sizetype==4, ntype="random size"; SeedRandom[20]; nvec0=n Table[.5 + Random[], len]];

 nvec=Round[nvec0];
 varT=sigmaB^2+(sigmaT^2)/nvec;
 seT=Sqrt[varT]//N;
 SeedRandom[20];
 errorT=(RandomVariate[NormalDistribution[0,#]])&  /@ seT;
 difTvec=b difSvec;
 difTvecR0=difTvec+errorT;
 difTvecR=Round[difTvecR0 10]/10//N;
wvec0=(sigmaT^2)/nvec//N;
wvec1=RandomVariate[NormalDistribution[#,4]]& /@ wvec0;

wvec=(Round[Sqrt[wvec1] 10]/10//N)^2;
seratio=sigmaB/sigmaT//N;
name="sim";
res={difSvec,difTvecR,nvec,wvec,name};
Return[res]]





End[] 
EndPackage[]

datasim1=GenDataSim[1,4];
datasim2=GenDataSim[2,4];
datasim3=GenDataSim[3,4];
Print["datasim1  datasim2 datasim3"];