(*Mathematica:: Version 7.0 *)
(*:Context:: "surrogate`" *)
(*:Title:: core estimates*)
(*Requirements:*)
 (*Date   2017 Stuart G. Baker *)  					
(*Input 
SFitPlot    sfitplot.m*)





BeginPackage["sfitmanu`", "sfitsimplot`", "sfitplot`","sfitdata`","sfitsim`","sfitlik`","sfitdatasim`"]  


SFitManu::usage="SFitManu"


Clear[SFitManu]

Begin["Private`"]

SFitManu[]:=
Module[{data1,data2,data3,dataManu},
data1=GenCancerData[1,False];
data2=GenCancerData[2,False];
data3=GenCancerData[3,False];
Print["data1 data2 data3"];
dataManu={data1,data2,data3};
SFitManuPlot[dataManu];
SFitSimPlot[];
SFitSim[];
Return[Null]]


SFitManuPlot[data_]:=
Module[{res,dim,lendim,x,sizenew,plot},
  sizenew=Automatic;
  show=False;
   dim=Dimensions[data];
    lendim=Length[dim];

plot=SFitCoreMany[data,x,sizenew,show];
  ExportPlot[plot,"fig2"];  
Return[Null]]


SFitCoreMany[dataset_,x_,sizenew_,show_]:=
Module[{plotvec,plotmat,plot,set,rvec,bmat,vmat,k,len,plotx},
set=SFitCore[#,x,sizenew,show]& /@ dataset;
{plot,SEMest, SEMmle,best,bmle,vest,vmle,wm,k}=Transpose[set];
showpar=False;
If[showpar,
(*slopes*)
  Print["Slopes"];
  headingsS={Automatic, {"num trials", "est", "mle"}};
  matS=Transpose[{k, best,bmle}];
  Print@TableForm[matS,TableHeadings->headingsS];
(*between SE*)
  Print["Between SE"];
  headings={Automatic, {"num trials","est", "mle"}};
  matB=Transpose[{k,Sqrt[vest],Sqrt[vmle]}];
  Print@TableForm[matB,TableHeadings->headings];
(*within SEM*)
  Print["SEM"];
  headings={Automatic, {"num trials", "est", "mle"}};
  matT=Transpose[{k, SEMest,SEMmle}];
  Print@TableForm[matT,TableHeadings->headings]];
 (*plot*) 
 len=Length[plot];
 If[OddQ[len], plotx=Join[plot,{Null}], plotx=plot];
plotmat=Partition[plotx,2];
plotx=Show[GraphicsGrid[plotmat],ImageSize->Large];
Return[plotx]]

SFitCore[data_,x_,sizenew_,show_]:=
Module[{check, name,xvec,yvec,nvec,plot,SEMest, SEMmle,best,bmle,vest,vmle,wm,k,nnew},
{xvec,yvec,nvec,wvec,name}=data;
If[show,
  mat=Transpose@{xvec,yvec,nvec,wvec};
  name={"surrogate eff", "true eff", "n", "var true"};
  Print@TableForm[mat,TableHeadings->{None,name}]];
If[sizenew===Automatic, 
   Print["using median size for new trial "];   nnew=Median[nvec],
   Print["using new trial size ",sizenew];    nnew=sizenew];
 {plot,SEMest, SEMmle,best,bmle,vest,vmle,wm,k}=SFitPlot[{xvec,yvec,nvec,wvec,name,nnew},x,show];
res={plot,SEMest, SEMmle,best,bmle,vest,vmle,wm,k};
Return[res]]


End[] 
EndPackage[]
